var Cus00100_CustoPlanejadoDoCardapioController = function (ScreenService, General, GeneralServices, templateManager) {
	/*global getLocalVar, Configuration, moment*/
	var self = this;
	
	this.defaultValues = function(widget) {
		if (!widget.currentRow.CDFILIAL) {
			widget.newRow();
		}
		var relatorio = widget.getField('CD_REPORT_NAME').dataSource.getFirstRow();
		var tipoDeCusto = widget.getField('NMTIPOCUSTO').dataSource.data[0];
		
		var date = moment(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY').format('DD/MM/YYYY');
		
		widget.getField('PERIODO').value(
			{
				'start': date,
				'end': date,
				'formattedEnd': date,
				'formattedStart': date
			}
		);
		
		widget.currentRow.DTINICIAL = date;
		widget.currentRow.DTFINAL = date;
		widget.currentRow.CD_REPORT_NAME = relatorio.value;
		if(tipoDeCusto){
			widget.getField('NMTIPOCUSTO').value(tipoDeCusto.NMTIPOCUSTO);
			widget.currentRow.CDTIPOCUSTO = tipoDeCusto.CDTIPOCUSTO;
		}
		
		widget.getField('NMGRUPSERV').setValue('');

		GeneralServices.retornaTipoCustoPadrao().then(function(callback) {
			if(callback.dataset.defaulttipocusto[0]) {
				widget.currentRow.CDTIPOCUSTO = callback.dataset.defaulttipocusto[0].CDTIPOCUSTO;
				widget.currentRow.NMTIPOCUSTO = callback.dataset.defaulttipocusto[0].NMTIPOCUSTO;
			}
		});
	};

	this.validacaoData = function (widget) {
		var dataInicial = moment(widget.currentRow.DTINICIAL, 'DD/MM/YYYY');
		var dataFinal 	= moment(widget.currentRow.DTFINAL, 'DD/MM/YYYY');
		var mensagem 	= ScreenService.i18n("A data final deve ser menor ou igual a data final.");

        if (dataInicial && dataFinal && dataFinal < dataInicial) {
            ScreenService.showMessage(mensagem);
            return false;
        }
        return true;
	};

	this.atualizaListaDeServico = function(widget) {
		var grupoServicos 	= '';
		var currentRow 		= widget.currentRow;

		if(currentRow.ALLGRUPSERV == 'N') {
			if (currentRow.NMGRUPSERV.length) {
				grupoServicos = currentRow.NMGRUPSERV.join('_');
			} else {
				grupoServicos = '';
			}
		} else {
			grupoServicos = 'T';
		} 
		General.onClickDependentField(widget.getField('NMSERVICO'), {CDFILIAL: currentRow.CDFILIAL, CDGRUPSERV: grupoServicos});
	};

	this.verificaCheckboxTodos = function(currentRow) {
		if (currentRow.ALLGRUPSERV == 'N' && currentRow.ALLSERVFILI == 'N') {
			currentRow.LISTAGRUPSERV = currentRow.NMGRUPSERV.join('_');
			currentRow.LISTASERV = currentRow.NMSERVICO.join('_');
		} else if (currentRow.ALLGRUPSERV == 'S' && currentRow.ALLSERVFILI == 'N') {
			currentRow.LISTAGRUPSERV = 'T';
			currentRow.LISTASERV = currentRow.NMSERVICO.join('_');
		} else if (currentRow.ALLGRUPSERV == 'N' && currentRow.ALLSERVFILI == 'S') {
			currentRow.LISTAGRUPSERV = currentRow.NMGRUPSERV.join('_');
			currentRow.LISTASERV = 'REQUEST';
		} else if (currentRow.ALLGRUPSERV == 'S' && currentRow.ALLSERVFILI == 'S') {
			currentRow.LISTAGRUPSERV = 'T';
			currentRow.LISTASERV = 'T';
		}
	};

	this.validacaoCampos = function(widget, row, currentRow) {
		var reportName = widget.currentRow.CD_REPORT_NAME;

		if(widget.isValid() && this.validacaoData(widget)) {
			var reportFormats = [
			    {
			        name: "pdf",
			        value: "PDF"
			    },
			    {
			        name: "xlsx",
			        value: "XLSX"
			    }
			];
	
			General.openReportPopup(widget, this.abreRelatorio, [reportName, row, currentRow], reportFormats);
		}
	};

	this.abreRelatorio = function(reportName, row, currentRow) {
		this.verificaCheckboxTodos(currentRow);
		General.openReport('cus_relatorio#/cus00100_custo_planejado_do_cardapio', reportName, row);
	}.bind(this);
	
	this.NMFILIALDefaultValue = function(){
		var widget = templateManager.container.getWidget('cus00100');
		
		widget.currentRow.CDFILIAL = getLocalVar('CDFILIAL');
		
		return getLocalVar('CDFILIAL')+" | "+getLocalVar('NMFILIAL');
	};
	
	this.exportDateValues = function(field){
		if(field.value()){
			field.widget.currentRow.DTINICIAL = field.value().start || '';
			field.widget.currentRow.DTFINAL = field.value().end || '';
		}
	};
	
	this.onChangeUnity = function(args){
		var field = args.owner.field;
		var widget = field.widget;
		
		widget.getField('NMSERVICO').setValue([]);
		if(!field.value()){
			widget.currentRow.CDFILIAL = '';
		}
	};
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Cus00100_CustoPlanejadoDoCardapioController', Cus00100_CustoPlanejadoDoCardapioController);
});