var Cus01300_CurvaABCGeralRealizadoController = function (ScreenService, restEngine, maskEngine, ZhUtil, General, GeneralServices) {
	var unidade;
	var filterReport;
	
	this.setaNomeRelatorio = function (widget) {
		if (!widget.currentRow.CDFILIAL) {
			widget.newRow();
		}
		if (!widget.backupRow){
			var date = getLocalVar('DTPROCESSA') ? moment(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY').format('DD/MM/YYYY') : moment().format('DD/MM/YYYY');
			var relatorio = widget.getField('REPORT_NAME').dataSource.getFirstRow();
			widget.currentRow.REPORT_NAME = relatorio.name;
			widget.currentRow.NMFILIAL = getLocalVar('CDFILIAL') + ' | '+ getLocalVar('NMFILIAL');
			widget.currentRow.CD_REPORT_NAME = relatorio.code;
			widget.currentRow.PERIODO = {
			   'start'         : date,
			   'end'           : date,
			   'formattedStart': date,
			   'formattedEnd'  : date
			};
			GeneralServices.retornaTipoCustoPadrao(getLocalVar('CDFILIAL')).then(function (callback) {
				if (callback.dataset.defaulttipocusto[0]) {
					widget.getField('NMTIPOCUSTO').setValue(callback.dataset.defaulttipocusto[0].NMTIPOCUSTO);
					widget.currentRow.CDTIPOCUSTO = callback.dataset.defaulttipocusto[0].CDTIPOCUSTO;
				}
			});
		} else {
			widget.currentRow = widget.backupRow;
		}
		
	};
	
	this.setValueProd = function (field){
		var widget = field.widget;
		if(field.name === 'NMPRODINICIO'){
			widget.currentRow.NMPRODFINAL = angular.copy(widget.currentRow.NMPRODINICIO);
			widget.currentRow.CDPRODFINAL = angular.copy(widget.currentRow.CDPRODINICIO);
			widget.currentRow.PRODUTOINIC = widget.currentRow.CDARVPROD;
			widget.currentRow.CDPRODINICIO = widget.currentRow.CDPRODUTO;
			widget.currentRow.PRODUTOFINA = widget.currentRow.CDARVPROD;
			widget.currentRow.CDPRODFINAL = widget.currentRow.CDPRODUTO;
		} else {
			widget.currentRow.PRODUTOFINA = widget.currentRow.CDARVPROD;
			widget.currentRow.CDPRODFINAL = widget.currentRow.CDPRODUTO;
		}
	};

	this.validaData = function (currentRow) {

		var dataInicial = currentRow.DTINICIAL ? moment(currentRow.DTINICIAL, 'DD/MM/YYYY')._d : null;
		var dataFinal = currentRow.DTFINAL ? moment(currentRow.DTFINAL, 'DD/MM/YYYY')._d : null;
		var mensagem = "A data final deve ser menor ou igual a data final.";

		if (dataInicial && dataFinal && dataFinal < dataInicial) {
			ScreenService.showMessage(mensagem);
			return false;
		}

		dataIni = currentRow.DTINICIAL;
		dataFim = currentRow.DTFINAL;

		var primeiroDia = moment(dataIni, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
		var ultimoDia = moment(dataFim, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY');

		currentRow.DTMESINIC = primeiroDia;
		currentRow.DTMESFINA = ultimoDia;
		return true;
	};

	this.tipoProduto = function (fieldIdEstocaveis, fieldIdNestocaveis) {
		var mensagem = "O tipo de produto não foi informado";

		if (!fieldIdNestocaveis.checked && !fieldIdEstocaveis.checked) {
			ScreenService.showMessage(mensagem);
			return false;
		}
		return true;
	};

	this.retornaCurvaABC = function (widget, currentRow) {

        var params = {
            route: "cus_relatorio#/cus01300_curva_abc_geral_realizado",
            reportName: currentRow.CD_REPORT_NAME,
            row: currentRow
		};
		var reportFormats = [
			{
				name: "pdf",
				value: "PDF"
			},
			{
				name: "xlsx",
				value: "XLSX"
			}
		];
        General.openReportPopup(widget, General.openReport, [params.route, params.reportName, params.row], reportFormats);
	};

	this.validaNivel = function (currentRow) {
		var mensagem = "O produto final não pode ser maior que o inicial.";
		var retorno = '';

		if (currentRow.PRODUTOINIC && currentRow.PRODUTOFINA) {
			retorno = General.comparaPratoProduto(currentRow.PRODUTOINIC, currentRow.PRODUTOFINA, getLocalVar('CDPICTPROD'));
			if (!retorno) {
				ScreenService.showMessage(mensagem);
				return false;
			}
			return true;
		}
		return false;
	};
	
	var prepareFilterReport = function(row, widget) {
		filterReport = [];
		var assoc = {
			'S': 'Sim',
			'Y': 'Sim',
			'N': 'Não'
		};
		var fields = ['NMFILIAL', 'PERIODO', 'NMTIPOCUSTO', 'NMPRODINICIO_NMPRODFINAL', 'IDESTOCAVEIS', 'IDNESTOCAVEIS'];
		fields.forEach(function(key){
			var field = widget.getField(key);
			if(field){
				var item = {
					'label': field.label,
					'value': typeof row[key] === 'object' ? row[key].start + ' até ' + row[key].end : row[key]
				};
				item.value = item.value === 'S' || item.value === 'Y' || item.value === 'N' ? assoc[item.value] : item.value;
				filterReport.push(item);
			} else if(key.indexOf('_') > -1){
				var produtos = key.split('_');
				var aux = {
					'label': 'Produto',
					'value': row[produtos[0]] + ' a ' + row[produtos[1]] 
				};
				filterReport.push(aux);
			}
		});
	};

	this.validaCampos = function (currentRow, fieldIdEstocaveis, fieldIdNestocaveis, widget) {
		currentRow.DTINICIAL = currentRow.PERIODO.start;
		currentRow.DTFINAL = currentRow.PERIODO.end;
		currentRow.DTMESFINA = currentRow.PERIODO.end;
		currentRow.DTMESINIC = currentRow.PERIODO.start;
		currentRow.CD_REPORT_NAME = 'CUS01300';
		currentRow.CDPICTPROD = getLocalVar('CDPICTPROD').replace(/[^(/\.|\ )]/g, "@");
		if (this.tipoProduto(fieldIdEstocaveis, fieldIdNestocaveis)) {
			if (widget.isValid() && this.validaData(currentRow) && this.validaNivel(currentRow)) {
				prepareFilterReport(currentRow, widget);
				this.retornaCurvaABC(widget, currentRow);
			}
		}
	};

	this.setaStripe = function (stripeWidget, parent) {

		stripeWidget.getField('unidade').setValue(unidade);
		stripeWidget.getField('CUSTOTOTPROD').setValue('');
		if (parent.length) {
			parent[0].CUSTOTOTPROD = applyMask(parent[0].CUSTOTOTPROD, 5);
			parent[0].CUSTOTOTPROD = typeof parent[0].CUSTOTOTPROD === 'string'? parent[0].CUSTOTOTPROD.split('.').join(',') : parent[0].CUSTOTOTPROD;
			stripeWidget.getField('CUSTOTOTPROD').setValue(parent[0].CUSTOTOTPROD);
		}
	};

	var applyMask = function (fieldValue, maxlength) {

		var mask = {
			"type": "zerofill",
			"params": {
				"right": true,
				"maxlength": maxlength
			}
		};
		return Util.applyMask(fieldValue, mask, maskEngine, ZhUtil);
	};
};

Configuration(function (ContextRegister) {
	ContextRegister.register('Cus01300_CurvaABCGeralRealizadoController', Cus01300_CurvaABCGeralRealizadoController);
});